from _typeshed import Incomplete
from collections.abc import Mapping
from strictyaml.exceptions import (
    InvalidOptionalDefault as InvalidOptionalDefault,
    YAMLSerializationError as YAMLSerializationError,
)
from strictyaml.representation import YAML as YAML
from strictyaml.ruamel.comments import (
    CommentedMap as CommentedMap,
    CommentedSeq as CommentedSeq,
)
from strictyaml.scalar import ScalarValidator as ScalarValidator, Str as Str
from strictyaml.validators import (
    MapValidator as MapValidator,
    SeqValidator as SeqValidator,
    Validator as Validator,
)
from strictyaml.yamllocation import YAMLChunk as YAMLChunk
from typing import Optional as _Optional, Union

class Optional:
    key: Incomplete
    default: Incomplete
    drop_if_none: Incomplete
    def __init__(
        self, key, default: Incomplete | None = ..., drop_if_none: bool = ...
    ) -> None: ...

_MapValidatorT = Mapping[Union[Optional, str], Validator]

class MapPattern(MapValidator):
    def __init__(
        self,
        key_validator,
        value_validator,
        minimum_keys: Incomplete | None = ...,
        maximum_keys: Incomplete | None = ...,
    ) -> None: ...
    @property
    def key_validator(self): ...
    def validate(self, chunk) -> None: ...
    def to_yaml(self, data): ...

class Map(MapValidator):
    def __init__(
        self, validator: _MapValidatorT, key_validator: _Optional[ScalarValidator] = ...
    ) -> None: ...
    @property
    def key_validator(self): ...
    def get_validator(self, key): ...
    def unexpected_key(self, key, yaml_key, value, chunk) -> None: ...
    def validate(self, chunk) -> None: ...
    def to_yaml(self, data): ...

class MapCombined(Map):
    def __init__(
        self,
        map_validator: _MapValidatorT,
        key_validator: Validator,
        value_validator: Validator,
    ) -> None: ...
    def get_validator(self, key): ...
    def unexpected_key(self, key, yaml_key, value, chunk) -> None: ...

class Seq(SeqValidator):
    def __init__(self, validator) -> None: ...
    def validate(self, chunk) -> None: ...
    def to_yaml(self, data): ...

class FixedSeq(SeqValidator):
    def __init__(self, validators) -> None: ...
    def validate(self, chunk) -> None: ...
    def to_yaml(self, data): ...

class UniqueSeq(SeqValidator):
    def __init__(self, validator) -> None: ...
    def validate(self, chunk) -> None: ...
    def to_yaml(self, data): ...
